# Licensed Materials - Property of IBM                       
# Component IBM Rational ROSE_RT BUILD : TARGET_RTS                 
# Copyright IBM Corporation 1999, 2008. All Rights Reserved.      
# U.S. Government Users Restricted Rights -  Use, duplication or    
# disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.



require 'tools/registry.pl';

$sdkKey = 'HKEY_LOCAL_MACHINE\\SOFTWARE\\Microsoft\\CEStudio\\3.0\\Setup';
$sdkSub = 'Windows CE Tools Dir';

$wceKey = "$sdkKey\\eMbedded Visual C++";
$wceSub = 'ProductDir';

$OSVERSION = 'WCE300';
$PLATFORM  = 'Pocket PC 2002';

unless( $SDKROOT = &ReadRegEntry( $sdkKey, $sdkSub, '' ) )
{
    print STDERR "Can't find registry SDK location '$sdkSub' at\n$sdkKey\n\n";
    exit 1;
}

unless( $WCEROOT = &ReadRegEntry( $wceKey, $wceSub, '' ) )
{
    print STDERR "Can't find registry WCE location '$wceSub' at\n$wceKey\n\n";
    exit 1;
}

{
    # Convenience variables, not exported
    my $sdk_ver_plat = "$SDKROOT\\$OSVERSION\\$PLATFORM";
    my $target       = 'sh3';

    $ENV{'INCLUDE'} =  "$sdk_ver_plat\\INCLUDE"
		    . ";$sdk_ver_plat\\MFC\\INCLUDE"
		    . ";$sdk_ver_plat\\ATL\\INCLUDE";

    $ENV{'LIB'}     =  "$sdk_ver_plat\\LIB\\$target"
		    . ";$sdk_ver_plat\\MFC\\LIB\\$target"
		    . ";$sdk_ver_plat\\ATL\\LIB\\$target";

    $ENV{'PATH'}    =  "$WCEROOT\\COMMON\\EVC\\BIN"
		    . ";$WCEROOT\\EVC\\$OSVERSION\\BIN"
		    . ";$ENV{'PATH'}";
}

$ENV{'OSVERSION'} = $OSVERSION;
$ENV{'PLATFORM'}  = $PLATFORM;
$ENV{'SDKROOT'}   = $SDKROOT;
$ENV{'WCEROOT'}   = $WCEROOT;

$ENV{'CC'}        = 'shcl.exe';
$ENV{'TARGETCPU'} = 'SH3';
$ENV{'CFG'}       = 'none';

$include_opt  = '/I';
@make_args    = ( '/nologo', '/f', '..\src\main.nmk' );
$object_ext   = '.OBJ';
$preprocessor = "$ENV{CC} /nologo /EP /P";
$target_base  = 'WINCE,NT40';
$supported    = 'Yes';
