/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTOutSignal_h__
#define __RTOutSignal_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTPriority_h__
#include <RTPriority.h>
#endif

class  RTMessage;
struct RTObject_class;
class  RTProtocol;

// It is common to make temporaries of this struct.
//lint -esym(1901,RTOutSignal)

struct RTOutSignal
{
    // general application use
    RTS_INLINE int invoke  (            RTMessage * replyBuffers );
    RTS_INLINE int invokeAt( int index, RTMessage * replyBuffer );
    RTS_INLINE int reply   ( void );
    RTS_INLINE int send    (            int priority = General );
    RTS_INLINE int sendAt  ( int index, int priority = General );

    // for use by run-time services library only
    RTS_INLINE RTOutSignal( RTProtocol           * port,
			    int                    signal,
			    const void           * data,
			    const RTObject_class * type );

    RTProtocol           * _port;
    int                    _signal;
    const void           * _data;
    const RTObject_class * _type;
}; //lint !e1712

#if RTS_INLINES
#include <RTOutSignal.inl>
#endif

#endif // __RTOutSignal_h__
