/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTSignal_h__
#define __RTSignal_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTInteger_h__
#include <RTInteger.h>
#endif

class RTSignal : public RTInteger
{
public:
    explicit                    RTSignal( int = 0 );
				RTSignal( const RTSignal & );
    virtual                     ~RTSignal( void );

    RTS_INLINE RTSignal       & operator=( int );
    RTS_INLINE RTSignal       & operator=( const RTSignal & );

    virtual const RTObject_class * getClassData( void ) const;
    static  const RTObject_class   classData;

#define RTType_RTSignal ( RTSignal::classData )
};

extern const RTSignal EmptySignal;

struct RTTypedValue_RTSignal
{
    const void           * data;
    const RTObject_class * type;

    RTS_INLINE RTTypedValue_RTSignal( const RTSignal       & ); //lint !e1931
    RTS_INLINE RTTypedValue_RTSignal( const RTSignal       &,
				      const RTObject_class * );
}; //lint !e1712

#if RTS_INLINES
#include <RTSignal.inl>
#endif

#endif // __RTSignal_h__
