/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTActor.h>
#include <RTActorRef.h>
#include <RTImportList.h>

int RTActor::isReferencedBy( const RTActor * other ) const
{
    const RTActor      * container = this;
    const RTImportList * imports;
    const RTActor      * owner;
    const RTActorRef   * homeRef;

    do
    {
	if( container == other )
	    return 1;

	for( imports  = container->importList;
	     imports != (RTImportList *)0;
	     imports  = imports->used.next )
	{
	    owner = imports->used.reference->getOwner();

	    if( owner == (const RTActor *)0 )
	    {
		// Every reference has an owner, but better safe than sorry!
	    }
	    else if( owner->isReferencedBy( other ) != 0 )
	    {
		return 1;
	    }
	}

	if( (homeRef = container->getReference()) == (RTActorRef *)0 )
	    break;
    }
    while( (container = homeRef->getOwner()) != (const RTActor *)0 );

    return 0;
}
