/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTActor.h>
#include <RTActorRef.h>
#include <RTComponentDescriptor.h>
#include <RTDebugger.h>

int RTActorRef::deport( RTActor * a )
{   
	// This is the initiator context
    RTController * controller = context();

    controller->trace( RTController::FrameDeport, this, (const void *)0 );

    if( a == (RTActor *)0 )
    {
	controller->setError( RTController::badActor,
			      RTController::FrameDeport,
			      this,
			      (const void *)0 );
	return 0;
    }

    if( _info->kind != RTComponentDescriptor::Imported )
    {
	controller->setError( RTController::notImported,
			      RTController::FrameDeport,
			      this,
			      (const void *)0 );
	return 0;
    }

    return a->removeImport( this ,controller);
}
