/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDaemon.h>
#include <RTDaemonInfo.h>
#include <RTMemoryUtil.h>

int RTDaemon::posInfo( RTDaemonInfo * newInfo )
{
    for( int iActor = 0; iActor < actorInfo.size(); ++iActor )
    {
	RTDaemonInfo * oldInfo = (RTDaemonInfo *)actorInfo[ iActor ];

	if( oldInfo == (RTDaemonInfo *)0 )
	    continue;

	if( newInfo == (RTDaemonInfo *)0 ) // delete no matter what
	    return iActor;

	if( oldInfo->daemonKind != newInfo->daemonKind )
	    continue;

	int length = newInfo->allRecurs != 0
		   ? RTMemoryUtil::strlen( newInfo->actorPath )
		   : -1;

	// actorPath must match
	if( RTMemoryUtil::strcmp( newInfo->actorPath,
				  oldInfo->actorPath,
				  length ) != 0 )
	{
	    continue;
	}

	// actorIndex must match unless allRecurs is true
	if( newInfo->allRecurs  == 0 &&
	    oldInfo->actorIndex != newInfo->actorIndex )
	{
	    continue;
	}

	// InfoActor: nothing more to compare; return match
	if( newInfo->daemonKind == RTDaemonInfo::InfoActor )
	    return iActor;

	// InfoPort: portPath must match, portIndex must match
	if( newInfo->daemonKind == RTDaemonInfo::InfoPort )
	{
	    if( RTMemoryUtil::strcmp( newInfo->portName,
				      oldInfo->portName ) != 0 )
	    {
		continue;
	    }

	    if( oldInfo->portIndex == newInfo->portIndex )
		return iActor;
	}

	// InfoState:

	// InfoChain:

	// InfoVariable: variableName must match
	if( newInfo->daemonKind == RTDaemonInfo::InfoVariable )
	{
	    if( RTMemoryUtil::strcmp( newInfo->variableName,
				      oldInfo->variableName ) == 0 )
	    {
		return iActor;
	    }
	}

    }
    return -1;
}
