/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDebugger.h>
#include <RTMessage.h>
#include <RTResourceMgr.h>

void RTDebugger::freeMsg( RTMessage * msg )
{
#if PURIFY
    delete msg;
#else
    const unsigned maxFreeListSize = 100U;
    const unsigned minFreeListSize =  20U;

    msg->clear();

    msg->next = freeList;
    freeList = msg;
    if( ++freeListSize > maxFreeListSize )
    {
	RTController::resourceMgr.msgFree( freeList,
					   freeListSize - minFreeListSize );
	freeListSize = minFreeListSize;
    }
#endif
}
