/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTActor.h>
#include <RTDebugger.h>
#include <RTDiag.h>
#include <RTDiagStream.h>

void RTDebugger::printActor( const RTActor * actor )
{
    const char * aname;
    const char * tname;
    const char * state;

    if( actor != (const RTActor *)0 )
    {
	aname = actor->getName();
	tname = actor->getTypeName();
	state = actor->getCurrentStateString();
    }
    else
    {
	aname = "<no-name>";
	tname = "System Actor";
	state = "<no-state>";
    }

    RTDiag::out() << aname << "(" << tname << ")<" << state << ">";
}
