/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTController.h>
#include <RTDebugger.h>
#include <RTMessage.h>
#include <RTSpecialSignals.h>

void RTDebugger::wakeup( RTController * controller )
{
    RTMessage * msg = newMsg();

    if( msg == (RTMessage *)0 )
    {
	controller->setError( RTController::noMem,
			      RTController::SystemService,
			      (const void *)0,
			      (const void *)0 );
    }
    else
    {
	msg->setSignal( RTWakeupSignal );
	msg->setPriority( Synchronous );
	msg->setDestination( (RTActor *)0, (RTProtocol *)0, 0 );

	controller->peer_receive( msg );
    }
}
