/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTIOMonitor.h>

void RTIOMonitor::add( int fd, int bits )
{
    if( fd < 0 || (bits &= RequestMask) == 0 )
	return;

    unsigned lo;
    unsigned hi;

    // Entries are sorted: do binary search.
    for( lo = 0U, hi = _used; lo < hi; )
    {
	unsigned   mid   = ( lo + hi ) >> 1;
	Entry    * entry = &_entries[ mid ];

	if( entry->fd == (unsigned)fd )
	{
	    entry->bits |= bits;
	    return;
	}

	if( entry->fd > (unsigned)fd )
	    hi = mid;
	else
	    lo = mid + 1U;
    }

    if( ++_used > _space )
    {
	_space += 32U;

	Entry    * new_entries = new Entry [ _space ];
	unsigned   index        = _used;

	while( --index > lo )
	    new_entries[ index ] = _entries[ index - 1U ];

	while( index-- != 0U )
	    new_entries[ index ] = _entries[ index ];

	delete [] _entries;

	_entries = new_entries;
    }
    else
    {
	for( unsigned index = _used; --index > lo; )
	    _entries[ index ] = _entries[ index - 1U ];
    }

    _entries[ lo ].fd   = (unsigned)fd;
    _entries[ lo ].bits = bits;
}
