/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTFieldDescriptor.h>
#include <RTObject_class.h>

void RTstruct_destroy( const RTObject_class * type, void * value )
{
    int                       count = type->_num_fields;
    const RTFieldDescriptor * field = &type->_fields[ count ];

    while( --field, --count >= 0 )
	field->destroy( value );

    const RTObject_class * super = type->_super;

    if( super != (const RTObject_class *)0 )
	(*super->_destroy_func)( type, (*type->_super_accessor)( value ) );
}
