/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDecoding.h>
#include <RTEncoding.h>
#include <RTObject_class.h>

static void ulong_init( const RTObject_class *, void * target )
{
    *(unsigned long *)target = 0UL;
}

static void ulong_copy( const RTObject_class *,
			void                 * target,
			const void           * source )
{
    *(unsigned long *)target = *(const unsigned long *)source;
}

#if OBJECT_DECODE
static int ulong_decode( const RTObject_class *,
			 void                 * target,
			 RTDecoding           * coding )
{
    return coding->get_ulong( *(unsigned long *)target );
}
#endif

#if OBJECT_ENCODE
static int ulong_encode( const RTObject_class *,
			 const void           * source,
			 RTEncoding           * coding )
{
    return coding->put_ulong( *(const unsigned long *)source );
}
#endif

const RTObject_class RTType_RTulong =
{
    (RTObject_class *)0,
    (RTSuperAccessFunction)0,
    "RTulong",
    (RTVersionId)0,
    (RTFieldOffset)sizeof( unsigned long ),
    ulong_init,
    ulong_copy,
#if OBJECT_DECODE
    ulong_decode,
#endif
#if OBJECT_ENCODE
    ulong_encode,
#endif
    RTnop_destroy,
    0, (const RTFieldDescriptor *)0
};

#if OBJECT_DECODE
RTTypeInstaller RTulong_installer( RTType_RTulong );
#endif
