/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTObserver.h>
#include <RTTcpSocket.h>

int RTObserver::sendData( const char * buffer, int length )
{
    int totalSent = 0;

    do
    {
	int sent = socket->write( buffer, length );

	if( sent <= 0 )
	    break;

	buffer    += sent;
	length    -= sent;
	totalSent += sent;
    }
    while( length > 0 );

    if( totalSent > 0 && length == 0 )
    {
	// we sent all we wanted to: cancel notification of room to write
	(void)socket->write( buffer, 0 );
    }

    return totalSent;
}
