/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTController.h>
#include <RTPortDescriptor.h>
#include <RTProtocol.h>

int RTProtocol::invokeAt( int                    index,
			  RTMessage            * replyBuffer,
			  int                    signal,
			  const void           * data,
			  const RTObject_class * type )
{
    RTController * invoker = context();

    invoker->trace( RTController::CommInvoke, this, &index );

#if RTTYPECHECK_SEND != RTTYPECHECK_DONT
    switch( sendCheck( signal, type ) )
    {
    case RTProtocolDescriptor::badSignal:
	invoker->setError( RTController::badSignal,
			   RTController::CommInvoke, this, &index );
#if RTTYPECHECK_SEND == RTTYPECHECK_FAIL
	return 0;
#else
	break;
#endif

    case RTProtocolDescriptor::badType:
	invoker->setError( RTController::badClass,
			   RTController::CommInvoke, this, &index );
#if RTTYPECHECK_SEND == RTTYPECHECK_FAIL
	return 0;
#else
	break;
#endif

    case RTProtocolDescriptor::ok:
    default:
	break;
    }
#endif // RTTYPECHECK_SEND != RTTYPECHECK_DONT

    if( index < 0 || _info->replication <= index )
    {
	invoker->setError( RTController::badIndex,
			   RTController::CommInvoke, this, &index );
	return 0;
    }

    return _ends[ index ].invoke( replyBuffer, invoker, this, index,
				  signal, data, type );
}
