/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTRelayPort.h>
#include <RTActor.h>

int RTRelayPort::followIn( RTBindingEnd & end,
			   RTActor      * owner,
			   int            id,
			   int            index,
			   int            size,
			   RTActorRef   * importer )
{
    if( index < 0 || size <= index )
    {
	// bad replication index
    }
    else if( importer != (RTActorRef *)0 )
    {
	if( _importers != (RTActorRef **)0 )
	{
	    int direct      = directUse( owner->getReference(), id );
	    int indirectUse = size - direct;

	    for( int i = 0; i < indirectUse; ++i )
		if( _importers[ i ] == importer && index-- == 0 )
		    return owner->_followInV( end, id, direct + i );
	}
    }
    else if( index < directUse( owner->getReference(), id ) )
    {
	return owner->_followInV( end, id, index );
    }

    return 0;
}
