/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTToolsetObserver.h>

//lint -save
//lint -esym(1927,RTToolsetObserver::rxBuffer)
//lint -esym(1927,RTToolsetObserver::structInfo)
//lint -esym(1927,RTToolsetObserver::txBuffer)
//lint -esym(1927,RTToolsetObserver::txTempBuffer)

RTToolsetObserver::RTToolsetObserver( RTDebugger  * theDebugger,
				      RTTcpSocket * theSocket,
				      int           theObsId,
				      const char  * initBuf,
				      int           initLen )
    : RTObserver( theDebugger, theSocket, theObsId, initBuf, initLen )
{
    enum
    {
	lengthSize = 4
      , dataSize   = 9999
      , bufferSize = lengthSize + dataSize
    };

    rxBuffer.size = 0;
    rxBuffer.data = (char *)0;

    txBuffer.size      = dataSize;
    txBuffer.used      = 0;
    txBuffer.start     = new char [ (unsigned)bufferSize ];
    txBuffer.data      = &txBuffer.start[ lengthSize ];

    txTempBuffer.size  = dataSize;
    txTempBuffer.used  = 0;
    txTempBuffer.start = new char [ (unsigned)bufferSize ];
    txTempBuffer.data  = &txBuffer.start[ lengthSize ];

    structInfo.func            =         0;
    structInfo.ptr             = (void *)0;
    structInfo.daemon.number   =         0;
    structInfo.daemon.invokeID = (char *)0;
}

//lint -restore
