/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDiag.h>
#include <RTDiagStream.h>
#include <RTFormat.h>
#include <RTMemoryUtil.h>
#include <RTToolsetObserver.h>

static bool didWarn = false;

void RTToolsetObserver::sendTxBuffer( void )
{
    RTAssert( 0 <= txBuffer.used && txBuffer.used <= 9999 );

    if( transmitData() == 0 )
    {
	if( ! didWarn )
	{
	    didWarn = true;
	    RTDiag::out() << "rosert: could not send message to Toolset\n";
	}

	return;
    }

    didWarn = false;

    enum { lengthDigits = 4 };

    char buf[ 2 * lengthDigits + 1 ];

    RTMemoryUtil::memset( buf, (int)'0', lengthDigits );

    int offset = RTFormat::_int( txBuffer.used, &buf[ lengthDigits ],
						lengthDigits + 1 );

    for( int i = 0; i < lengthDigits; ++i )
	txBuffer.start[ i ] = buf[ offset + i ];

    txBuffer.data  = txBuffer.start;
    txBuffer.used += lengthDigits;

    int nrSent = sendData( txBuffer.data, txBuffer.used );

    txBuffer.data += nrSent;
    txBuffer.used -= nrSent;

    if( txBuffer.used > 0 ) // this send failed - copy remaining
    {
	txTempBuffer.data = txTempBuffer.start;
	txTempBuffer.used = txBuffer.used;

	for( char * p = txTempBuffer.data; --txBuffer.used >= 0; )
	{
	    *p++ = *txBuffer.data++;
	}
    }

    txBuffer.data = &txBuffer.start[ lengthDigits ];
}
