/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTMemoryUtil.h>
#include <RTinet.h>
#include <RTtcp.h>

extern "C" int RTinet_bind( int                    sock,
			    const RTinet_address * address,
			    RTinet_port            port )
{
    sockaddr_in addr;

    RTMemoryUtil::memset( &addr, 0, (int)sizeof( addr ) );

    addr.sin_family = AF_INET;
    addr.sin_port   = (unsigned short)htons( port );

    if( address != (const RTinet_address *)0 )
	RTMemoryUtil::memcpy( &addr.sin_addr, address,
					      (int)sizeof( *address ) );

    //lint -save -e740
    while( INET_bind( sock,
		      (SocketAddress *)&addr,
		      (int)sizeof( addr ) ) != 0 )
    //lint -restore
    {
#ifdef INET_EINTR
	if( INET_error( sock ) == INET_EINTR )
	    continue;
#endif

	return 0;
    }

    return 1;
}
