/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTinet.h>
#include <RTtcp.h>

extern "C" int RTinet_TCP_create( void )
{
    int sock;

    while( (sock = INET_socket( AF_INET, SOCK_STREAM, 0 )) == INET_NO_SOCKET )
    {
#ifdef INET_EINTR
	if( INET_error( sock ) == INET_EINTR )
	    continue;
#endif

	return INET_NO_SOCKET;
    }

    if( RTinet_async      ( sock ) == 0 ||
	RTinet_nonblocking( sock ) == 0 ||
	RTinet_reuseaddr  ( sock ) == 0 )
    {
	RTinet_close( sock );
	return INET_NO_SOCKET;
    }

    return sock;
}
