/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTinet_h__
#define __RTinet_h__ included

#ifndef __RTConfig_h__
#include <RTConfig.h>
#endif

#if HAVE_INET

extern "C"
{

typedef struct { char b[ 4 ]; } RTinet_address;
typedef unsigned short          RTinet_port;

#define INET_NO_SOCKET ( -1 )

extern const RTinet_address RTinet_loopback;

extern int  RTinet_TCP_create( void );
extern int  RTinet_UDP_create( void );
extern int  RTinet_accept( int, RTinet_address *, RTinet_port * );
extern int  RTinet_async( int );
extern int  RTinet_bind( int, const RTinet_address *, RTinet_port );
extern void RTinet_close( int );
extern int  RTinet_connect( int, const RTinet_address *, RTinet_port );
extern int  RTinet_getname( int, RTinet_address *, RTinet_port * );
extern int  RTinet_listen( int );
extern int  RTinet_lookup( const char *, RTinet_address * );
extern int  RTinet_nonblocking( int );
extern int  RTinet_primary( int, RTinet_address * );
extern int  RTinet_read( int, char *, int );
extern int  RTinet_recvfrom( int, char *, int,
			     RTinet_address *, RTinet_port * );
extern int  RTinet_reuseaddr( int );
extern int  RTinet_sendto( int, const char *, int,
			   const RTinet_address *, RTinet_port );
extern int  RTinet_write( int, const char *, int );

}

#endif // HAVE_INET

#endif // __RTinet_h__
