# Licensed Materials - Property of IBM                       
# Component IBM Rational ROSE_RT BUILD : TARGET_RTS                 
# Copyright IBM Corporation 1999, 2008. All Rights Reserved.      
# U.S. Government Users Restricted Rights -  Use, duplication or    
# disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.

RTS_HOME=..

# libset.mk will replace this definition
# with an empty one if shared libraries are not supported

SHLIBS = $(ACTOR_SHLIB) $(DATA_SHLIB)

# Final action, after main.o and all libraries are built.

WRAPUP = $(NOP)

libraries : all
	@ $(NOP)

include $(RTS_HOME)/libset/default.mk
include $(RTS_HOME)/libset/$(LIBRARY_SET)/libset.mk
include $(RTS_HOME)/target/$(TARGET)/target.mk
include $(RTS_HOME)/config/$(CONFIG)/config.mk

CC_ECHO = $(FEEDBACK) Compiling

ACTOR_LIB       = $(RTS_LIBRARY)/libObjecTime$(LIB_EXT)
ACTOR_SHLIB     = $(RTS_LIBRARY)/libObjecTime$(SHLIB_EXT)
DATA_LIB        = $(RTS_LIBRARY)/libObjecTimeTypes$(LIB_EXT)
DATA_SHLIB      = $(RTS_LIBRARY)/libObjecTimeTypes$(SHLIB_EXT)

all : $(ACTOR_LIB) $(DATA_LIB) $(SHLIBS) OTHERS
	@ $(WRAPUP)

# Here, we include the list of explicit dependencies.
# The rules are much too complicated for the average make program.

include depend.mk

$(ACTOR_LIB) : $(A_OBJECTS)
	@ $(FEEDBACK)
	@ $(FEEDBACK) Building $(@F) ...
	@ $(AR_CMD) $(LIBOUT_OPT) $(LIBOUT_TAG)"$@" "%A.olist"

$(DATA_LIB) : $(D_OBJECTS)
	@ $(FEEDBACK)
	@ $(FEEDBACK) Building $(@F) ...
	@ $(AR_CMD) $(LIBOUT_OPT) $(LIBOUT_TAG)"$@" "%D.olist"

$(ACTOR_SHLIB) : $(A_OBJECTS)
	@ $(FEEDBACK)
	@ $(FEEDBACK) Building $(@F) ...
	@ $(RMF) $@
	@ $(SHLIB_CMD) $(SHLIBOUT_OPT) $(SHLIBOUT_TAG)"$(@F)" "%A.olist"
	@ $(MV) $(@F) $@

$(DATA_SHLIB) : $(D_OBJECTS)
	@ $(FEEDBACK)
	@ $(FEEDBACK) Building $(@F) ...
	@ $(RMF) $@
	@ $(SHLIB_CMD) $(SHLIBOUT_OPT) $(SHLIBOUT_TAG)"$(@F)" "%D.olist"
	@ $(MV) $(@F) $@

OTHERS : $(M_OBJECTS) $(Z_OBJECTS)
	@ $(NOP)

FORCE :
	@ $(NOP)

# A shorter list of suffixes reduces the time spent searching for applicable
# implicit rules. This makefile doesn't rely on implicit rules so the list
# could be empty, but some implementations of make seem to think this is worth
# noting so we just put .cc in the list to eliminate those warnings.

.SUFFIXES :
.SUFFIXES : $(CPP_EXT)
