/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDiag.h>
#include <RTTimespec.h>

#include <time.h>
#if TARGET_LYNX < 31
#include <sys/timers.h>
#endif

void RTTimespec::getclock( RTTimespec & ts )
{
    timespec now;

#if TARGET_LYNX >= 31
    if( clock_gettime( CLOCK_REALTIME, &now ) != 0 )
	RTDiag::panic( "clock_gettime" );
#else
    ::getclock( TIMEOFDAY, &now );
#endif

    ts.tv_sec  = now.tv_sec;
    ts.tv_nsec = now.tv_nsec;
}
