/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifdef PRAGMA
#pragma implementation "RTThreadInfo.h"
#endif

#include <RTDiag.h>
#include <RTJob.h>
#include <RTThread.h>
#include <RTThreadInfo.h>

static void thread_run( RTJob * job )
{
    job->mainLoop();
}

RTThread::RTThread( RTJob * job, int stack_size, int prio )
    : _job ( job )
    , _info( new RTThreadInfo )
{
    HANDLE handle;
    DWORD  tid;

    if( (handle = CreateThread( (LPSECURITY_ATTRIBUTES)0,
				(DWORD)stack_size, //lint !e571 !e732
				(LPTHREAD_START_ROUTINE)thread_run,
				(LPVOID)job,
				(DWORD)CREATE_SUSPENDED, &tid )) == (HANDLE)0 )
	RTDiag::panic( "RTThread(create)" );
    else if( SetThreadPriority( handle, THREAD_PRIORITY_NORMAL + prio ) == 0 )
	RTDiag::panic( "RTThread(priority)" );
    else if( ResumeThread( handle ) != (DWORD)1 )
	RTDiag::panic( "RTThread(resume)" );
    else
	_info->handle = handle;
}

RTThreadInfo::RTThreadInfo( void )
    : handle( (HANDLE)0 )
{
}

RTThreadInfo::~RTThreadInfo( void )
{
    if( handle != (HANDLE)0 )
    {
	if( WaitForSingleObject( handle, (DWORD)INFINITE ) == WAIT_FAILED )
	    RTDiag::panic( "RTThreadInfo(wait)" );

	if( CloseHandle( handle ) == 0 )
	    RTDiag::panic( "RTThreadInfo(close)" );

#ifdef _lint
	handle = (HANDLE)0;
#endif
    }
}
