/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTMemoryUtil.h>
#include <RTinet.h>
#include <RTtcp.h>

extern "C" int RTinet_accept( int              listener,
			      RTinet_address * address,
			      RTinet_port    * port )
{
    int         sock;
    addr_struct peer;
    short       peer_size = (short)sizeof( peer );

    if( (sock = NU_Accept( listener, &peer, &peer_size )) == NU_INVALID_SOCKET )
	return INET_NO_SOCKET;

    if( ! RTinet_async( sock ) || ! RTinet_nonblocking( sock ) )
    {
	RTinet_close( sock );
	return INET_NO_SOCKET;
    }

    RTMemoryUtil::memcpy( address, &peer.id, (int)sizeof( *address ) );
    *port = peer.port;

    return sock;
}
