/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTTimespec.h>

struct RTTimeConsts
{
    unsigned long ticks_per_sec;
    unsigned long nsec_per_tick;
};

static RTTimeConsts tc = { 100, 10000000 };   // for 10msec tick

static unsigned long RTClk_ticks = 0;  // Increment this each interrupt clock
				       // using RTClk_Tick

void RTTimespec::getclock( RTTimespec & ts )
{
    unsigned long now = RTClk_ticks;

    ts.tv_sec  =  now / tc.ticks_per_sec;
    ts.tv_nsec =  ( now % tc.ticks_per_sec ) * tc.nsec_per_tick;
}

// Call from clock interrupt handler to increment time.
void RTClk_Tick( void )
{
    ++RTClk_ticks;
}

unsigned long RTticks_per_sec( void )
{
    return tc.ticks_per_sec;
}

unsigned long RTnsec_per_tick( void )
{
    return tc.nsec_per_tick;
}
