/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifdef PRAGMA
#pragma implementation "RTThreadInfo.h"
#endif

#include <RTJob.h>
#include <RTThread.h>
#include <RTThreadInfo.h>

static void job_run( void * arg )
{
    ((RTJob *)arg)->mainLoop();
}

RTThread::RTThread( RTJob * job, int stack_size, int prio )
    : _job (              job )
    , _info( new RTThreadInfo )
{
    _info->task = RTTaskManager::startTask( job_run, job, prio, stack_size );
}

RTThreadInfo::RTThreadInfo( void )
    : task( (RTTask *)0 )
{
}

RTThreadInfo::~RTThreadInfo( void )
{
    if( task != (RTTask *)0 )
	RTTaskManager::joinTask( task );

#ifdef _lint
    job = (RTJob *)0;
#endif
}
