/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTtcp_h__
#define __RTtcp_h__ included

#include <errno.h>
#include <pna.h>
#include <psos.h>

#ifndef IFF_LOOPBACK
#define IFF_LOOPBACK IFF_EXTLOOPBACK
#endif
#define IFF_RUNNING  0

typedef struct sockaddr_in SocketAddress;
typedef int                SocketAddressSize;

#define INET_HaveLength    0

#define INET_accept        (int)accept
#define INET_bind          bind
#define INET_close         close
#define INET_connect       connect
#define INET_error( sd )   errno
#define INET_getsockname   getsockname
#define INET_listen        listen
#define INET_lookup        gethostbyname
#define INET_recv          (int)recv
#define INET_recvfrom      recvfrom
#define INET_setsockopt    setsockopt
#define INET_socket        socket

#define INET_ioctl( sock, cmd, arg ) \
			   ioctl( (sock), (cmd), (char *)(arg) )

#define INET_send( sock, data, size, flags ) \
			   (int)send( (sock), (char *)(data), (size), (flags) )

#define INET_sendto( sock, data, size, flags, dst, dst_len ) \
			   (int)sendto( (sock), (char *)(data), (size), \
					(flags), (dst), (dst_len) )

#define INET_EALREADY      EALREADY
#define INET_EINPROGRESS   EINPROGRESS
#define INET_EINTR         EINTR
#define INET_EISCONN       EISCONN
#define INET_EWOULDBLOCK   EWOULDBLOCK

#endif // __RTtcp_h__
