/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTSyncObject_h__
#define __RTSyncObject_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTConfig_h__
#include <RTConfig.h>
#endif

#include <semLib.h>

struct RTTimespec;

class RTSyncObject
{
protected:
    SEM_ID  sem_id;

public:
	    RTSyncObject( void );
	    ~RTSyncObject( void );

    void    signal( void );
    void    wait( void );
    void    timedwait( const RTTimespec & );

private:
    // unavailable methods
    RTSyncObject( const RTSyncObject & );
    RTSyncObject & operator=( const RTSyncObject & );
};

#endif // __RTSyncObject_h__
