/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTWinCE.h>

void RTConsole::scroll( int rows, int cols )
{
    int old_top  = screen.top;
    int old_left = screen.left;
    int last_row = buffer.rows - screen.rows;
    int last_col = buffer.cols - screen.cols;

    if( last_row < 0 )
	last_row = 0;

    if( last_col < 0 )
	last_col = 0;

    screen.top  += rows;
    screen.left += cols;

    if( screen.top < 0 )
	screen.top = 0;
    else if( screen.top > last_row )
	screen.top = last_row;

    if( screen.left < 0 )
	screen.left = 0;
    else if( screen.left > last_col )
	screen.left = last_col;

    rows = old_top - screen.top;
    cols = old_left - screen.left;

    if( rows != 0 || cols != 0 )
    {
	RECT       rc;
	SCROLLINFO si;

	GetClientRect( window, &rc );
	makeCaret( CaretHidden );
	ScrollWindowEx( window,
			cols * character.width,
			rows * character.height,
			(const RECT *)0, &rc,
			(HRGN)0, (RECT *)0, SW_INVALIDATE /* | SW_ERASE */ );

	if( rows != 0 )
	{
	    // adjust the vertical scrollbar
	    si.cbSize = sizeof( si );
	    si.fMask  = SIF_RANGE | SIF_POS | SIF_PAGE;
	    si.nMin   = 0;
	    si.nMax   = buffer.rows - 1;
	    si.nPos   = screen.top;
	    si.nPage  = screen.rows;
	    SetScrollInfo( window, SB_VERT, &si, TRUE );
	    makeCaret( CaretVisible );
	}

	if( cols != 0 )
	{
	    // adjust the horizontal scrollbar
	    si.cbSize = sizeof( si );
	    si.fMask  = SIF_RANGE | SIF_POS | SIF_PAGE;
	    si.nMin   = 0;
	    si.nMax   = buffer.cols - 1;
	    si.nPos   = screen.left;
	    si.nPage  = screen.cols;
	    SetScrollInfo( window, SB_HORZ, &si, TRUE );
	    makeCaret( CaretVisible );
	}
    }
}
