#! perl -w

# Licensed Materials - Property of IBM                       
# Component IBM Rational ROSE_RT BUILD : TARGET_RTS                 
# Copyright IBM Corporation 1999, 2008. All Rights Reserved.      
# U.S. Government Users Restricted Rights -  Use, duplication or    
# disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.



sub fatal
{
    print STDERR "$_[0]\n";
    exit 1;
}

$#ARGV >= 0 || &fatal( "Usage: ${0} source-file ..." );

binmode( STDOUT );

@pragmas = ();

foreach $in ( @ARGV )
{
    open( IN, $in ) || &fatal( "$in: $!" );

    while( <IN> )
    {
	if( m{^#\s*pragma\b} )
	{
	    push @pragmas, $_;
	}
    }

    close( IN  ) || &fatal( "$in: $!" );
}

if( $#pragmas >= 0 )
{
    print "#ifdef PRAGMA\n", @pragmas, "#endif\n";
}

foreach $in ( @ARGV )
{
    open( IN, $in ) || &fatal( "$in: $!" );

    $level = 0;
    while( <IN> )
    {
	if( m{^#\s*ifdef\s+PRAGMA} )
	{
	    ++$level;
	}
	elsif( $level > 0 )
	{
	    --$level if( m{^#\s*endif} );
	}
	else
	{
	    s{^#\s*include\s*<(.*)>.*$}{#include "$1"};
	    print;
	}
    }

    close( IN  ) || &fatal( "$in: $!" );
}
